//*************************************************************
//
//@@@@@@@@@@n@ҏW\tg
//	@@@@@@@@@@u@KanjiBlankPlayer@v
//@@@@@@@@@@@@@@@version 1.1
//
//@@@@@@@@@@@@ҁF[g؁@@@[TN129/J119]
//
//*************************************************************
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;

public class KanjiBlankFrame extends JFrame implements ActionListener, WindowListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	//******************************************************************************************************
	//N
	//------------------------------------------------------------------------------------------------------
	public static void main(String[] args) {
		KanjiBlankFrame frame=new KanjiBlankFrame();
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//
	//^Cgɕt镶
	private static final String TITLE_STRING=" - KanjiBlankPlayer";
	//
	KanjiBlankPanel puzzleField;		//pY{
	KanjiBlankFileIO fileIO;			//Z[ut@C(*.txtj̏o
	KanjiBlankNewDialog newDialog;		//VKpY쐬_CAO
	KanjiBlankSizeDialog sizeDialog;	//TCYύX_CAO
	KanjiBlankAppletDialog appletDialog;//Weby[Wo̓_CAO
	//
	JMenuBar mainMenu=new JMenuBar();
	//
	JMenu menuFile=new JMenu("t@C(F)");
	JMenuItem menuItemNew=new JMenuItem("VK(N)...");
	JMenuItem menuItemChange=new JMenuItem("ύX(C)...");
	JMenuItem menuItemOpen=new JMenuItem("J(O)");
	JMenuItem menuItemSave=new JMenuItem("㏑ۑ(S)");
	JMenuItem menuItemSaveAs=new JMenuItem("Otĕۑ(R)...");
	JMenuItem menuItemGraphicOut=new JMenuItem("摜ۑ(G)...");
	JMenuItem menuItemPrint=new JMenuItem("(P)...");
	JMenuItem menuItemExit=new JMenuItem("I(X)");
	//
	JMenu menuEdit=new JMenu("ҏW(E)");
	JRadioButtonMenuItem menuItemAnswer=new JRadioButtonMenuItem("𓚃[h(A)");
	JRadioButtonMenuItem menuItemEdit=new JRadioButtonMenuItem("̓[h(E)");
	JMenuItem menuItemClear=new JMenuItem("𓚏(C)");
	JMenuItem menuItemOverlapChar=new JMenuItem("d(R)");
	JMenuItem menuItemSort=new JMenuItem("nёւ(S)");
	//
	JMenu menuView=new JMenu("\(V)");
	JMenuItem menuItemSize=new JMenuItem("\TCY(S)...");
	JMenuItem menuItemSizeFit=new JMenuItem("t[TCY(F)");
	JCheckBoxMenuItem menuItemCursor=new JCheckBoxMenuItem("J[\\(C)");
	JCheckBoxMenuItem menuItemErrorView=new JCheckBoxMenuItem("ԂŎ(E)");
	//
	JMenu menuCheck=new JMenu("`FbN(C)");
	JMenuItem menuItemErrorDetect=new JMenuItem("G[o(D)");
	JMenuItem menuItemErrorRemove=new JMenuItem("G[폜(R)");
	//
	JMenu menuIO=new JMenu("o(P)");
	JMenuItem menuItemAppletOut=new JMenuItem("Weby[Wo(W)...");
	//
	JMenu menuHelp=new JMenu("wv(H)");
	JMenuItem menuItemAbout=new JMenuItem("KanjiBlankPlayerɂ(A)");
	//******************************************************************************************************
	//it[̃^CgύXfileIOsj
	//------------------------------------------------------------------------------------------------------
	public KanjiBlankFrame(){
		//TCYݒ
		//iŏɏ\傫ݒ肵Ă˂΁AŃTCYsĂLĂȂBȂ낤Hj
		setSize(600,600);
		//Reig
		Container cp=getContentPane();
		//
		puzzleField=new KanjiBlankPanel(this);
		JScrollPane scPanel=new JScrollPane(puzzleField);
		cp.add(scPanel,BorderLayout.CENTER);
		//
		//WI{^ݒ
		ButtonGroup bg=new ButtonGroup();
		bg.add(menuItemAnswer);
		bg.add(menuItemEdit);
		menuItemAnswer.setSelected(true);
		puzzleField.changePuzzleMode(KanjiBlankPanel.MODE_ANSWER);
		//`FbN{bNXݒ
		menuItemCursor.setSelected(true);
		//puzzleField.setCursorViewFlag(menuItemCursor.getState());
		menuItemErrorView.setSelected(true);
		//
		fileIO=new KanjiBlankFileIO(this);
		setTitleString();	//^Cgݒ͏o̓NX쐬
		//
		newDialog=new KanjiBlankNewDialog(this);
		sizeDialog=new KanjiBlankSizeDialog(this);
		appletDialog=new KanjiBlankAppletDialog(this);
		//
		menuFile.add(menuItemNew);
		menuFile.add(menuItemChange);
		menuFile.add(menuItemOpen);
		menuFile.addSeparator();
		menuFile.add(menuItemSave);
		menuFile.add(menuItemSaveAs);
		menuFile.addSeparator();
		menuFile.add(menuItemGraphicOut);
		menuFile.add(menuItemPrint);
		menuFile.addSeparator();
		menuFile.add(menuItemExit);
		//
		menuEdit.add(menuItemAnswer);
		menuEdit.add(menuItemEdit);
		menuEdit.addSeparator();
		menuEdit.add(menuItemClear);
		menuEdit.add(menuItemOverlapChar);
		menuEdit.add(menuItemSort);
		//
		menuView.add(menuItemSize);
		menuView.add(menuItemSizeFit);
		menuView.add(menuItemCursor);
		menuView.add(menuItemErrorView);
		//
		menuCheck.add(menuItemErrorDetect);
		menuCheck.add(menuItemErrorRemove);
		//
		menuIO.add(menuItemAppletOut);
		//
		menuHelp.add(menuItemAbout);
		//
		mainMenu.add(menuFile);
		mainMenu.add(menuEdit);
		mainMenu.add(menuView);
		mainMenu.add(menuCheck);
		mainMenu.add(menuIO);
		mainMenu.add(menuHelp);
		setJMenuBar(mainMenu);
		//j[jbNiL[{[hAlt+?őIj
		menuFile.setMnemonic(KeyEvent.VK_F);
		menuItemNew.setMnemonic(KeyEvent.VK_N);
		menuItemChange.setMnemonic(KeyEvent.VK_C);
		menuItemOpen.setMnemonic(KeyEvent.VK_O);
		menuItemSave.setMnemonic(KeyEvent.VK_S);
		menuItemSaveAs.setMnemonic(KeyEvent.VK_R);
		menuItemGraphicOut.setMnemonic(KeyEvent.VK_G);
		menuItemPrint.setMnemonic(KeyEvent.VK_P);
		menuItemExit.setMnemonic(KeyEvent.VK_X);
		menuEdit.setMnemonic(KeyEvent.VK_E);
		menuItemAnswer.setMnemonic(KeyEvent.VK_A);
		menuItemEdit.setMnemonic(KeyEvent.VK_E);
		menuItemClear.setMnemonic(KeyEvent.VK_C);
		menuItemOverlapChar.setMnemonic(KeyEvent.VK_R);
		menuItemSort.setMnemonic(KeyEvent.VK_S);
		menuView.setMnemonic(KeyEvent.VK_V);
		menuItemSize.setMnemonic(KeyEvent.VK_S);
		menuItemSizeFit.setMnemonic(KeyEvent.VK_F);
		menuItemCursor.setMnemonic(KeyEvent.VK_C);
		menuItemErrorView.setMnemonic(KeyEvent.VK_E);
		menuCheck.setMnemonic(KeyEvent.VK_C);
		menuItemErrorDetect.setMnemonic(KeyEvent.VK_D);
		menuItemErrorRemove.setMnemonic(KeyEvent.VK_R);
		menuIO.setMnemonic(KeyEvent.VK_P);
		menuItemAppletOut.setMnemonic(KeyEvent.VK_W);
		menuHelp.setMnemonic(KeyEvent.VK_H);
		menuItemAbout.setMnemonic(KeyEvent.VK_A);
		//ANZ[^[iL[{[h̃V[gJbgj
		menuItemNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,Event.CTRL_MASK));
		menuItemOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,Event.CTRL_MASK));
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,Event.CTRL_MASK));
		menuItemSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,Event.CTRL_MASK));
		menuItemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,Event.CTRL_MASK));
		menuItemAnswer.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));
		menuItemEdit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
		//ẽCxg
		menuItemNew.addActionListener(this);
		menuItemChange.addActionListener(this);
		menuItemOpen.addActionListener(this);
		menuItemSave.addActionListener(this);
		menuItemSaveAs.addActionListener(this);
		menuItemGraphicOut.addActionListener(this);
		menuItemPrint.addActionListener(this);
		menuItemExit.addActionListener(this);
		menuItemAnswer.addActionListener(this);
		menuItemEdit.addActionListener(this);
		menuItemClear.addActionListener(this);
		menuItemOverlapChar.addActionListener(this);
		menuItemSort.addActionListener(this);
		menuItemSize.addActionListener(this);
		menuItemSizeFit.addActionListener(this);
		menuItemCursor.addActionListener(this);
		menuItemErrorView.addActionListener(this);
		menuItemErrorDetect.addActionListener(this);
		menuItemErrorRemove.addActionListener(this);
		menuItemAppletOut.addActionListener(this);
		menuItemAbout.addActionListener(this);
		addWindowListener(this);
		//t[TCY߂Ɏg߃XN[̈niƕ𓾂Ȃ̂ōŌɓnj
		puzzleField.setScrollEdge(scPanel);
	}
	//******************************************************************************************************
	//j[Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==menuItemNew){
			if(checkChangedData()){		//pYpOɃpYf[^ύXȂ`FbN
				newDialog.setType(KanjiBlankNewDialog.TYPE_NEW);
				newDialog.setVisible(true);
			}
		}else if(object==menuItemChange){
			//݂̃f[^𔽉fĕ\ipYf[^ύX̃`FbN͕svj
			newDialog.setSizeMax(puzzleField.puzzleData.height, puzzleField.puzzleData.width, puzzleField.puzzleData.charMax);
			newDialog.setType(KanjiBlankNewDialog.TYPE_CHANGE);
			newDialog.setVisible(true);
		}else if(object==menuItemOpen){
			if(checkChangedData()){		//pYpOɃpYf[^ύXȂ`FbN
				fileIO.load(puzzleField);
				fitFrameSize(false);
			}
		}else if(object==menuItemSave){
			fileIO.save(puzzleField);
		}else if(object==menuItemSaveAs){
			fileIO.saveAs(puzzleField);
		}else if(object==menuItemGraphicOut){
			fileIO.outputGraphic(puzzleField);
		}else if(object==menuItemPrint){
			fileIO.printField(puzzleField);
		}else if(object==menuItemExit){
			if(checkChangedData()){		//IOɃpYf[^ύXȂ`FbN
				System.exit(0);
			}
		}else if(object==menuItemAnswer){
			puzzleField.changePuzzleMode(KanjiBlankPanel.MODE_ANSWER);
		}else if(object==menuItemEdit){
			puzzleField.changePuzzleMode(KanjiBlankPanel.MODE_EDIT);
		}else if(object==menuItemClear){
			puzzleField.formatAnswer();
		}else if(object==menuItemOverlapChar){
			puzzleField.removeOverlapChar();
		}else if(object==menuItemSort){
			puzzleField.sortWords();
		}else if(object==menuItemSize){
			sizeDialog.setValue(puzzleField.getCellSize());
			sizeDialog.setVisible(true);
		}else if(object==menuItemSizeFit){
			fitFrameSize(true);		//t[pYɃsb^킹
		}else if(object==menuItemCursor){
			puzzleField.setCursorViewFlag(menuItemCursor.getState());
		}else if(object==menuItemErrorView){
			puzzleField.setErrorViewFlag(menuItemErrorView.getState());
		}else if(object==menuItemErrorDetect){
			puzzleField.checkQuestion();
		}else if(object==menuItemErrorRemove){
			puzzleField.removeError();
		}else if(object==menuItemAppletOut){
			appletDialog.setLatestData();
			appletDialog.setVisible(true);
		}else if(object==menuItemAbout){
			JOptionPane.showMessageDialog(this,
					"KanjiBlankPlayer version 1.1\n\nTakanaFactory\nhttp://www.takana.info/",
					"KanjiBlankPlayerɂ",JOptionPane.INFORMATION_MESSAGE);
		}
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	//-------------------------------------------------------------
	//VKpY쐬
	public void newPuzzle(int ht,int wd,int chMx){
		puzzleField.formatPuzzle(ht, wd,chMx);
		fileIO.formatFileName();
		//
		fitFrameSize(false);
	}
	//-------------------------------------------------------------
	//TCYύX
	public void changePuzzle(int ht,int wd,int chMx){
		puzzleField.changePuzzle(ht, wd,chMx);
		//
		fitFrameSize(false);
	}
	//-------------------------------------------------------------
	//t[TCYpYɍ킹Ē
	//iĂ΂邪A}X̃TCYύXSizeDialogڌĂ΂j
	//ij[ut[TCY߁v̂݃sb^tOtruej
	public void fitFrameSize(boolean shortenFlag){
		Dimension differ=puzzleField.getSizeDifference();	//TCYߏ蕪擾
		if(!shortenFlag){	//sb^ɒȂȂ傫̂͂̂܂
			if(differ.width>0){		differ.width=0;		}
			if(differ.height>0){	differ.height=0;	}
		}
		setSize(getWidth()-differ.width,getHeight()-differ.height);
		setVisible(true);	//1sƃt[̃tB[hȂǂTCYȂiȂHj
	}
	//-------------------------------------------------------------
	//}X̃TCYύX
	public void changeSquareSize(int v){
		//ꎞIɃ}Xƃpl̃TCŶݕύX
		puzzleField.setCellSize(v);
		puzzleField.adjustPanelSize();
		//ł̓t[TCY͕ύXȂiŏIISLSizeDialog璼ڂj
	}
	//-------------------------------------------------------------
	//t[^Cgݒ
	public void setTitleString(){
		if(puzzleField.checkChanged()){	//f[^ύXiɈĎj
			setTitle("*"+fileIO.getFileName()+TITLE_STRING);
		}else{							//f[^ύXȂ
			setTitle(fileIO.getFileName()+TITLE_STRING);
		}
	}
	//-------------------------------------------------------------
	//G[_CAOŒʒm
	public void showErrorDialog(String message){
		JOptionPane.showMessageDialog(this,message,"G[",JOptionPane.ERROR_MESSAGE);
	}
	//******************************************************************************************************
	//EBhECxg
	//------------------------------------------------------------------------------------------------------
	public void windowOpened(WindowEvent e) {
	}
	public void windowClosing(WindowEvent e) {
		if(checkChangedData()){		//OɃpYf[^ύXȂ`FbN
			System.exit(0);
		}
	}
	public void windowClosed(WindowEvent e) {
	}
	public void windowIconified(WindowEvent e) {
	}
	public void windowDeiconified(WindowEvent e) {
	}
	public void windowActivated(WindowEvent e) {
	}
	public void windowDeactivated(WindowEvent e) {
	}
	//pYf[^ύXΒӂ𑣂AZ[uipȂtrueԂj
	private boolean checkChangedData(){
		if(puzzleField.checkChanged()){
			int ret=JOptionPane.showConfirmDialog(this,"eύXĂ܂B\nۑ܂H",
					"mF",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
			if(ret==JOptionPane.YES_OPTION){
				fileIO.save(puzzleField);
			}else if(ret==JOptionPane.CANCEL_OPTION){
				return false;
			}
		}
		return true;
	}
}
