import java.awt.BorderLayout;
import java.awt.Container;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;

import javax.swing.JApplet;

public class KanjiBlankApplet extends JApplet {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	KanjiBlankPanel puzzleField;
	//
	//*************************************************************
	//
	//-------------------------------------------------------------
	public void init()	{
		//
		puzzleField=new KanjiBlankPanel(null);
		//}X̃TCY
		puzzleField.setCellSize(getParam("size",26));
		//
		String questionFile=getParam("datafile","");
		if(!questionFile.equals("")){	//f[^t@C̈ʒuƖOǂݍ
			String[] puzzleData=readTextFile(questionFile);
			if(puzzleData.length>0){
				puzzleField.setLoadString(puzzleData);
			}
		}
		//Reig
		Container cp=getContentPane();
		cp.add(puzzleField,BorderLayout.CENTER);
		//
		puzzleField.requestFocus();
	}
	//*************************************************************
	//f[^擾
	//-------------------------------------------------------------
	//eLXgt@Cǂݍ
	private String[] readTextFile(String fileOrder) {
		String ret[];
		try{
			URL targetURL=new URL(getDocumentBase(),fileOrder);
			BufferedReader br=new BufferedReader(new InputStreamReader(targetURL.openStream()));
			//
			ArrayList<String> list=new ArrayList<String>();
			String str;
			while( (str=br.readLine())!=null ){
				list.add(str);
			}
			//
			br.close();
			//
			ret=new String[list.size()];
			for(int i=0;i<ret.length;i++){
				ret[i]=list.get(i);
			}
		}catch(IOException e){
			ret=new String[0];
		}
		//
		return ret;
	}
	//*************************************************************
	//p[^[擾
	//-------------------------------------------------------------
	public String getParam(String param, String defStr) {
		String str=getParameter(param);
		if(str==null){ return defStr; }
		return str;
	}
	public int getParam(String param, int defInt) {
		String str=getParameter(param);
		if(str==null){ return defInt; }
		try{
			return Integer.parseInt(str);
		}catch(NumberFormatException e){
			return defInt;
		}
	}
	public boolean getParam(String param, boolean defBool) {
		String str=getParameter(param);
		if(str==null){ return defBool; }
		if(defBool){
			if(str.equals("off")){	return false;	}
		}else{
			if(str.equals("on")){	return true;	}
		}
		return defBool;
	}
}
