import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class KanjiBlankAppletDialog extends JDialog implements ActionListener, DocumentListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	KanjiBlankFrame frame;
	//
	JFileChooser chooser;
	//
	JTextField fieldPath=new JTextField(20);
	JButton buttonPath=new JButton("Weby[W");
	//
	JTextField fieldTitle=new JTextField("KanjiBlankApplet",18);
	//
	JTextField fieldCell=new JTextField("26",2);
	JTextField fieldWidth=new JTextField(3);
	JTextField fieldHeight=new JTextField(3);
	//
	JTextField fieldData=new JTextField(5);
	//
	JButton buttonOk=new JButton("o");
	JButton buttonCancel=new JButton("");
	//o̓t@Cf[^
	File targetFile;
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KanjiBlankAppletDialog(KanjiBlankFrame frm){
		super(frm,"pYWeby[Wɏo",true);
		frame=frm;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//
		//ڂ͕ҏWłȂ
		fieldPath.setEditable(false);
		fieldWidth.setEditable(false);
		fieldHeight.setEditable(false);
		//
		//
		JPanel panelHTML=new JPanel();	//1-1
		panelHTML.add(fieldPath);
		panelHTML.add(buttonPath);
		//
		JPanel panelTitle=new JPanel();	//1-2
		panelTitle.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"^Cg"));	//g
		panelTitle.add(fieldTitle);
		//
		JPanel panelSize=new JPanel();	//1-3
		panelSize.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"TCY"));	//g
		panelSize.add(new JLabel("}XF"));
		panelSize.add(fieldCell);
		panelSize.add(new JLabel("@AppletF "));
		panelSize.add(fieldWidth);
		panelSize.add(new JLabel("~c"));
		panelSize.add(fieldHeight);
		//
		JPanel panelData=new JPanel();	//1-4
		panelData.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"f[^"));	//g
		panelData.add(new JLabel("o͐F"));
		panelData.add(fieldData);
		panelData.add(new JLabel(".csv"));
		//
		JPanel panelCenter=new JPanel();	//1
		panelCenter.setLayout(new GridLayout(3,1));
		panelCenter.add(panelTitle);
		panelCenter.add(panelSize);
		panelCenter.add(panelData);
		//
		JPanel panelButton=new JPanel();	//2
		panelButton.add(buttonOk);
		panelButton.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(panelHTML,BorderLayout.NORTH);
		cp.add(panelCenter,BorderLayout.CENTER);
		cp.add(panelButton,BorderLayout.SOUTH);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		calcAppletSize();	//QƂRg[
		//
		buttonPath.addActionListener(this);
		fieldCell.getDocument().addDocumentListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//o͐
		targetFile=null;
	}
	//******************************************************************************************************
	//\OɍŐVf[^K
	//------------------------------------------------------------------------------------------------------
	public void setLatestData(){
		//}XTCY
		fieldCell.setText(String.valueOf(frame.puzzleField.getCellSize()));
		calcAppletSize();
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPath){				//Weby[Ww
			getTargetHTML();
		}else if(object==buttonOk){
			if(checkDataConform()){
				setVisible(false);
				//
				if( !KanjiBlankFileIO.writeTextFile(targetFile, getHTMLString()) ){
					frame.puzzleField.showErrorMessage("Weby[W݂Ɏs܂B","G[");
				}
				//
				if( !KanjiBlankFileIO.writeTextFile(new File(targetFile.getParent(),fieldData.getText()+".csv"), frame.puzzleField.getSaveString(false)) ){
					frame.puzzleField.showErrorMessage("pYf[^݂Ɏs܂B","G[");
				}
				//JAR
				if( !frame.fileIO.copySelfJarFile(targetFile.getParent()) ){
					frame.puzzleField.showErrorMessage("vOt@CiJARj̃Rs[Ɏs܂B","G[");
				}
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	//}X̃TCYwtB[h̕ύXCxg
	//------------------------------------------------------------------------------------------------------
	public void insertUpdate(DocumentEvent e) {
		calcAppletSize();
	}
	public void removeUpdate(DocumentEvent e) {
		calcAppletSize();
	}
	public void changedUpdate(DocumentEvent e) {
		//no work
	}
	//******************************************************************************************************
	//Applet̃TCYvZi}XTCYŕςj
	//------------------------------------------------------------------------------------------------------
	private void calcAppletSize(){
		try{
			int cell=Integer.parseInt(fieldCell.getText());
			if(cell<8 || cell>80){
				fieldWidth.setText("");
				fieldHeight.setText("");
				return;
			}
			//
			int w=cell*(frame.puzzleField.getPuzzleWidth()+1);
			fieldWidth.setText(""+w);
			//
			int h=cell*(frame.puzzleField.getPuzzleHeight()+1);
			fieldHeight.setText(""+h);
		}catch(NumberFormatException exc){
			fieldWidth.setText("");
			fieldHeight.setText("");
		}
	}
	//******************************************************************************************************
	//o͐擾
	//------------------------------------------------------------------------------------------------------
	private void getTargetHTML(){
		chooser.setSelectedFile(targetFile);
		chooser.setDialogTitle("Weby[W(*.htm,*.html)o͐I");
		int ret=chooser.showDialog(this, "I");
		if(ret==JFileChooser.APPROVE_OPTION){
			targetFile=chooser.getSelectedFile();
			//gqtĂȂΕt
			targetFile=KanjiBlankFileIO.addExtension(targetFile, "htm","html");
			//
			fieldData.setText(targetFile.getName().substring(0, targetFile.getName().lastIndexOf(".") ));
			fieldPath.setText(targetFile.getPath());
		}
	}
	//******************************************************************************************************
	//Weby[Wo͓e
	//------------------------------------------------------------------------------------------------------
	private String getHTMLString(){
		final String br=System.getProperty("line.separator");
		StringBuffer out=new StringBuffer();
		//
		out.append("<html>").append(br);
		out.append("<head>").append(br);
		out.append("<title>"+fieldTitle.getText()+"</title>").append(br);
		out.append("</head>").append(br);
		out.append("<body>").append(br);
		out.append("<br>").append(br);
		out.append("<center>").append(br);
		out.append("<applet code=\"KanjiBlankApplet.class\" archive=\"KanjiBlankPlayer.jar\" width=\""+fieldWidth.getText()+"\" height=\""+fieldHeight.getText()+"\">").append(br);
		out.append("<param name=\"datafile\" value=\""+fieldData.getText()+".csv\">").append(br);
		out.append("<param name=\"size\" value=\""+fieldCell.getText()+"\">").append(br);
		out.append("</applet>").append(br);
		out.append("<br>").append(br);
		out.append("<br>").append(br);
		out.append("ɂ<a href=\"http://java.com/ja/\" target=\"_blank\">Javasihttp://java.com/ja/j</a>Kv").append(br);
		out.append("</center>").append(br);
		out.append("</body>").append(br);
		out.append("</html>").append(br);
		//
		return out.toString();
	}
	//******************************************************************************************************
	//̓f[^̐`FbN
	//------------------------------------------------------------------------------------------------------
	private boolean checkDataConform(){
		if(targetFile==null){
			frame.puzzleField.showErrorMessage("Weby[W̏o͐w肵ĂB","G[");
			return false;
		}
		if(fieldData.getText().equals("")){
			frame.puzzleField.showErrorMessage("f[^̏o͐w肵ĂB","G[");
			return false;
		}
		try{
			int cell=Integer.parseInt(fieldCell.getText());
			if(cell<8 || cell>80){
				frame.puzzleField.showErrorMessage("}X̃TCY8`80̐w肵ĂB","G[");
				return false;
			}
		}catch(NumberFormatException e){
			frame.puzzleField.showErrorMessage("}X̃TCY8`80̐w肵ĂB","G[");
			return false;
		}
		//
		return true;
	}
}
