import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

public class KanjiBlankNewDialog extends JDialog implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//----------萔------------
	//
	static final int TYPE_NEW=0;
	static final int TYPE_CHANGE=1;
	//----------ϐ------------
	//Ăяo
	KanjiBlankFrame frame;
	//
	JRadioButton radioNew=new JRadioButton("VK");
	JRadioButton radioChange=new JRadioButton("ύX");
	//
	SpinnerNumberModel spinnerVer=new SpinnerNumberModel(KanjiBlankData.DEF_HEIGHT,1,20,1);
	SpinnerNumberModel spinnerHor=new SpinnerNumberModel(KanjiBlankData.DEF_WIDTH,2,10,1);
	//
	SpinnerNumberModel spinnerCharMax=new SpinnerNumberModel(KanjiBlankData.DEF_CHAR_MAX,2,10,1);
	//
	JButton buttonOk=new JButton("");
	JButton buttonCancel=new JButton("");
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KanjiBlankNewDialog(KanjiBlankFrame frm){
		super(frm,"VK쐬EύX",true);
		frame=frm;
		//
		JPanel panelType=new JPanel();
		panelType.add(radioNew);
		panelType.add(radioChange);
		//
		JPanel panelSize=new JPanel();
		panelSize.add(new JLabel("^eF"));
		panelSize.add(new JSpinner(spinnerVer));
		panelSize.add(new JLabel(" X RF"));
		panelSize.add(new JSpinner(spinnerHor));
		//
		JPanel panelMax=new JPanel();
		panelMax.add(new JLabel("ő啶F"));
		panelMax.add(new JSpinner(spinnerCharMax));
		//
		JPanel panelSizeMax=new JPanel();
		panelSizeMax.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"TCY"));	//g
		panelSizeMax.setLayout(new GridLayout(2,1));
		panelSizeMax.add(panelSize);
		panelSizeMax.add(panelMax);
		//
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(panelType,BorderLayout.NORTH);
		cp.add(panelSizeMax,BorderLayout.CENTER);
		cp.add(panelBtn,BorderLayout.SOUTH);
		//
		pack();							//TCY
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		ButtonGroup radioGroup=new ButtonGroup();
		radioGroup.add(radioNew);
		radioGroup.add(radioChange);
		radioNew.setSelected(true);
		//
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonOk){
			setVisible(false);
			//wTCY
			int ht=Integer.parseInt(spinnerVer.getValue().toString());
			int wd=Integer.parseInt(spinnerHor.getValue().toString());
			int chMx=Integer.parseInt(spinnerCharMax.getValue().toString());
			//
			if(radioNew.isSelected()){					//VK
				frame.newPuzzle(ht, wd,chMx);
			}else/* if(radioChange.isSelected())*/{		//ύX
				frame.changePuzzle(ht, wd, chMx);
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	//VKEύX̐؂ւ
	//------------------------------------------------------------------------------------------------------
	public void setType(int type){
		switch(type){
		case TYPE_NEW:
			radioNew.setSelected(true);
			break;
		case TYPE_CHANGE:
			radioChange.setSelected(true);
			break;
		}
	}
	public void setSizeMax(int ht,int wd,int max){
		spinnerVer.setValue(ht);
		spinnerHor.setValue(wd);
		spinnerCharMax.setValue(max);
	}
}
